# $Id: cpuinfo.spec 1194 2011-04-23 04:12:28Z rpmbuild $
# repo: RE
# restrictions:

%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%define svndate	20090313

%bcond_without	perl
%bcond_without	python

Summary:	A CPU identification tool and library
Name:		cpuinfo
Version:	1.0
Release:	%RErelease 1
# based on branch at https://code.launchpad.net/cpuinfo/trunk, please don't
# replace until merged upstream
Source0:	%{name}-%{version}%{?svndate:-%{svndate}}.tar.bz2
# This patch is already commited to branch above, patch added here in stead of
# updating tarball for just one commit..
Patch500:	cpuinfo-1.0-no-64bit-if-32bit-personality.patch
# lame workaround for now..
Patch501:	cpuinfo-1.0-dont-report-64bit-on-32bit.patch
License:	GPLv2+ and LGPLv2+
Group:		System Environment/Kernel
Url:		http://gwenole.beauchesne.info/projects/cpuinfo/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	rpm-macros-razorsedge
ExclusiveArch:	%{ix86} x86_64 ppc ppc64 ia64
%if %{with perl}
%if (0%{?fedora} > 11 || 0%{?rhel} > 5)
BuildRequires:	perl-devel
%endif
%endif
%if %{with python}
BuildRequires:	python-devel, python-setuptools
%endif

%description
cpuinfo consists of an API/library used by programs to get information
about the underlying CPU. Such information includes CPU vendor, model
name, cache hierarchy, and supported features (e.g. CMP, SMT, and
SIMD). cpuinfo is also a standalone program to demonstrate the use of
this API.

%package	devel
Summary:	Development files for cpuinfo
Group:		Development/Libraries
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{name}%{?_isa} = %{version}-%{release}
%if (0%{?rhel} == 5)
Requires:	pkgconfig
%endif

%description 	devel
This package contains headers and libraries needed to use cpuinfo's
processor characterisation features in your programs.

%package -n	perl-Cpuinfo
Summary:	Perl bindings for cpuinfo
Group:		Development/Languages

%description -n	perl-Cpuinfo
Provides a Perl API to the cpuinfo library.

%package -n	python-cpuinfo
Summary:	Python bindings for cpuinfo
Group:		Development/Languages

%description -n python-cpuinfo
Provides a Python API to the cpuinfo library.

%prep
%setup -q
%patch500 -p0 -b .no64bit_if_32bit_personality~
%patch501 -p0 -b .no64bit_if_32bit~

%build
%configure \
	--enable-shared \
%if %{with perl}
	--enable-perl=vendor \
%endif
%if %{with python}
	--enable-python \
%endif
	--install-sdk
%{__make}

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
%{__make} DESTDIR=$RPM_BUILD_ROOT install

# nuke unpackaged files
find $RPM_BUILD_ROOT -name cpuinfo.pl -exec rm -f {} \;
find $RPM_BUILD_ROOT -name perllocal.pod -exec rm -f {} \;
find $RPM_BUILD_ROOT -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -name libcpuinfo.a -exec rm -f {} \;
find $RPM_BUILD_ROOT -name Cpuinfo.so -exec chmod 0755 {} \;
find $RPM_BUILD_ROOT -name CPUInfo.so -exec chmod 0755 {} \;

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc README COPYING* NEWS
%{_bindir}/cpuinfo
%{_libdir}/libcpuinfo.so.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/cpuinfo.h
%{_libdir}/pkgconfig/libcpuinfo.pc
%{_libdir}/libcpuinfo.so

%if %{with perl}
%files -n perl-Cpuinfo
%defattr(-,root,root,-)
%doc src/bindings/perl/cpuinfo.pl
%{perl_vendorarch}/Cpuinfo.pm
%dir %{perl_vendorarch}/auto/Cpuinfo
%{perl_vendorarch}/auto/Cpuinfo/*
%endif

%if %{with python}
%files -n python-cpuinfo
%defattr(-,root,root,-)
%{python_sitearch}/CPUInfo.so
%dir %{python_sitearch}/pycpuinfo-*.egg-info/
%{python_sitearch}/pycpuinfo-*.egg-info/*
%endif

%changelog
* Fri Apr 22 2011 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.0-1
- Hacked spec file to build on CentOS and Fedora.

* Tue Nov 17 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.0-0.20090313.4mdv2010.1
+ Revision: 466991
- split static library into a separate package
- don't report 64 bit if built for 32 bit (P501)
- add dependency on library package for devel package

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild

* Thu Mar 19 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.0-0.20090313.2mdv2009.1
+ Revision: 357588
- only report 64bit if PER_LINUX_32BIT personality isn't set (P0)

* Fri Mar 13 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.0-0.20090313.1mdv2009.1
+ Revision: 354626
- add missing buildrequires
- build shared library, perl & python bindings
- update copyright tag
- cosmetics
  update to snapshot from my own bzr branch:
  	o adds python bindings
  	o adds feature detection of ancient features all the way back to
  	  'alignment check' to latest and greatest described in intel & amd manuals
  	o several improvements for making it easier for rpm5 to use library

* Thu Jan 17 2008 Olivier Blin <oblin@mandriva.com> 1.0-0.20070715.1mdv2008.1
+ Revision: 153914
- update to 20070715 snapshot
- restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed May 09 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 1.0-0.20070509.1mdv2008.0
+ Revision: 25631
- update from SVN (2007/05/09):
  * add Perl bindings
  * fix detection of VIA processors (C3, C7)
  * fix detection of early AMD processors (K5, K6)
  * add more x86 feature flags (3dnow, sse4, popcnt)

* Wed Apr 18 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 1.0-0.20070415.1mdv2008.0
+ Revision: 14616
- initial mandriva linux package

* Tue Feb 14 2006 Nicolas Lécureuil <neoclust@mandriva.org> 0.3-3mdk
- Fix BuildRequires

* Sat Feb 11 2006 Sebastien Savarin <plouf@mandriva.org> 0.3-2mdk
- Fix wrong perms

* Sat Feb 11 2006 Sebastien Savarin <plouf@mandriva.org> 0.3-1mdk
- First Mandriva Linux release

